HorschTigerLT = {};


function HorschTigerLT.prerequisitesPresent(specializations)
    return true;
end;

function HorschTigerLT:load(xmlFile)

	self.anim = SpecializationUtil.callSpecializationsFunction("anim");
	self.Go = {}; 
	self.Done = {};
	self.charId = {};
	self.clipIndex = {};
	self.CheckDone = {};
	self.moveColli = {}; 
    self.animationParts = {};
	self.collisionArm = {};
	self.startpoint = {};
	self.loopCheck = {};
	self.Speed = {};
	local count = getXMLInt(xmlFile, "vehicle.animationParts#count");
	local part = self.animationParts;
	if count ~= nil then
	    for i=1, count do
			part[i] = {};
	        local partname = string.format("vehicle.animationParts.part".."%d", i);
		    local nameR = getXMLString(xmlFile, partname.."#name");
			self.charId[nameR] = Utils.indexToObject(self.components, getXMLString(xmlFile, partname.."#rootNode"));
			self.clipIndex[nameR] = getXMLString(xmlFile, partname.."#animationClip");
			self.CheckDone[nameR] = false;
			self.moveColli[nameR] = getXMLString(xmlFile, partname.."#moveColli");
			self.startpoint[nameR] = Utils.getNoNil(getXMLFloat(xmlFile, partname.."#startpoint"),0.0);
			self.Speed[nameR] = Utils.getNoNil(getXMLFloat(xmlFile, partname.."#speed"),0.0);
			local charId = getAnimCharacterSet(self.charId[nameR]);
			local clipIndex = getAnimClipIndex(charId, self.clipIndex[nameR]);
			assignAnimTrackClip(charId , 0, clipIndex);
			setAnimTrackTime(charId, 0, self.startpoint[nameR]);
			enableAnimTrack(charId, 0);
			disableAnimTrack(charId, 0);
			self.loopCheck[nameR] = false;
			self.Speed[nameR] = 1.0;
		end; 
	end;

	self.moveUp = false;
	self.foldingIn = false;
	self.saveAiLeftMarker = self.aiLeftMarker;
	self.doJointOrientation = false;
	self.attacherJointCopy = nil;
	self.isHorschTiger = true;
	
end;

function HorschTigerLT:delete()
end;

function HorschTigerLT:mouseEvent(posX, posY, isDown, isUp, button)
end;

function HorschTigerLT:keyEvent(unicode, sym, modifier, isDown)
end; 

function HorschTigerLT:update(dt)
	for k, joint in pairs(self.componentJoints) do
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
	end;
	if self.doJointOrientation and self.attacherVehicle ~= nil then
		for k,v in pairs(self.attacherVehicle.attachedImplements) do
			if v.object == self then
				local joint = self.attacherVehicle.attacherJoints[v.jointDescIndex];
				self.attacherJointCopy = joint;
				self.rotationCopyMin = {joint.minRot[1], joint.minRot[2], joint.minRot[3]};
				self.rotationCopyMax = {joint.maxRot[1], joint.maxRot[2], joint.maxRot[3]};
				joint.minRot[1] = math.rad(14);
				joint.maxRot[1] = math.rad(-8);
				self.moveUp = not joint.moveDown;
				joint.allowsJointLimitMovement = false;
			end;
		end;
		self.doJointOrientation = false;
	end;
	self:anim("HorschTigerLTSupport", false);
	self:anim("HorschTigerLTFold", false);
	self:anim("HorschTigerLTFoldBack", false);
	self:anim("HorschTigerLTFoldBackDrum", false);
	self:anim("HorschTigerLTHub", false);
	if self:getIsActiveForInput() then
		if InputBinding.hasEvent(InputBinding.LOWER_IMPLEMENT) then
			self.Speed.HorschTigerLTFoldBackDrum = 1;
			self.moveUp = not self.moveUp;
		end;
		if InputBinding.hasEvent(InputBinding.HorschTigerLT_FOLD) then
			self.Speed.HorschTigerLTFold = 1;
			self.Speed.HorschTigerLTFoldBackDrum = 1;
			self.foldingIn = not self.foldingIn;
			self.moveUp = true;
			self.attacherJointCopy.moveDown = not self.moveUp;
		end;
		if self.moveUp then
			if self.CheckDone.HorschTigerLTFold == false then
				self.Go.HorschTigerLTFoldBackDrum = true;
				self.Done.HorschTigerLTFoldBackDrum = true;
			end;
			self.Go.HorschTigerLTHub = true;
			self.Done.HorschTigerLTHub = true;
			if not self.foldingIn then
				self.Go.HorschTigerLTFoldBack = true;
				self.Done.HorschTigerLTFoldBack = true;
			end;
			if self.CheckDone.HorschTigerLTHub == true then
				if self.foldingIn then
					self.Go.HorschTigerLTFold = true;
					self.Done.HorschTigerLTFold = true;
					self.Go.HorschTigerLTFoldBackDrum = true
					self.Done.HorschTigerLTFoldBackDrum = true;
				else
					self.Go.HorschTigerLTFold = false;
					self.Done.HorschTigerLTFold = true;
					self.Go.HorschTigerLTFoldBack = true;
					self.Done.HorschTigerLTFoldBack = true;
				end;
			end;
			if self.CheckDone.HorschTigerLTFold and self.foldingIn then
				self.Go.HorschTigerLTFoldBack = false;
				self.Done.HorschTigerLTFoldBack = true;
			end;
		else
			self.Go.HorschTigerLTHub = false;
			self.Done.HorschTigerLTHub = true;
			if self.CheckDone.HorschTigerLTFold == false then
				self.Go.HorschTigerLTFoldBackDrum = false;
				self.Done.HorschTigerLTFoldBackDrum = true;
			else
				self.Go.HorschTigerLTFoldBackDrum = true;
				self.Done.HorschTigerLTFoldBackDrum = true;
			end;
		end;
	end;
	if self.foldingIn == false then
		setJointRotationLimit(self.componentJoints[3].jointIndex, 0, true, math.rad(-1), math.rad(1));
		setJointRotationLimit(self.componentJoints[4].jointIndex, 0, true, math.rad(-1), math.rad(1));
		if self.CheckDone.HorschTigerLTFoldBack == true then
			setJointRotationLimit(self.componentJoints[5].jointIndex, 0, true, math.rad(-10), math.rad(10));
			setJointRotationLimit(self.componentJoints[6].jointIndex, 0, true, math.rad(-10), math.rad(10));
		end;
	else
		setJointRotationLimit(self.componentJoints[3].jointIndex, 0, true, 0, 0);
		setJointRotationLimit(self.componentJoints[4].jointIndex, 0, true, 0, 0);
		if self.CheckDone.HorschTigerLTFoldBack == true then
			setJointRotationLimit(self.componentJoints[5].jointIndex, 0, true, math.rad(0), math.rad(0));
			setJointRotationLimit(self.componentJoints[6].jointIndex, 0, true, math.rad(0), math.rad(0));
		end;
	end;
	if self.CheckDone.HorschTigerLTHub == false and self.CheckDone.HorschTigerLTFold == false then
		setJointRotationLimit(self.componentJoints[2].jointIndex, 0, true, math.rad(-2), math.rad(2));
	else
		setJointRotationLimit(self.componentJoints[2].jointIndex, 0, true, 0, 0);
	end;
	if self.attacherVehicle ~= nil then
		if self.foldingIn == false then
			if self.CheckDone.HorschTigerLTFold == false then
				self.aiLeftMarker = self.saveAiLeftMarker;
				AITractor.updateToolsInfo(self.attacherVehicle);
			end;
		else
			self.aiLeftMarker = nil;
			AITractor.updateToolsInfo(self.attacherVehicle);
		end;
		if self.attacherVehicle.isAITractorActivated then
			self.attacherVehicle.aiTurnNoBackward = true;
			if self.attacherVehicle.turnStage ~= 0 then
				if self.attacherVehicle.rotatedTime >= 0.485 then
					self.attacherVehicle.rotatedTime = 0.485;
				elseif self.attacherVehicle.rotatedTime <= -0.485 then
					self.attacherVehicle.rotatedTime = -0.485;
				else
					self.attacherVehicle.rotatedTime = self.attacherVehicle.rotatedTime;
				end;
			end;
		end;
	end;
end;

function HorschTigerLT:draw()
	if self.attacherVehicle ~= nil then
		if self.CheckDone.HorschTigerLTFold == false and not self.foldingIn then
			g_currentMission:addHelpButtonText(g_i18n:getText("HorschTigerLT_3"), InputBinding.HorschTigerLT_FOLD);
		else
			g_currentMission:addHelpButtonText(g_i18n:getText("HorschTigerLT_4"), InputBinding.HorschTigerLT_FOLD);
		end;
		if g_currentMission.attachableInMountRange then
			g_currentMission.hudAttachmentOverlay:render();
		end;
	end;
end;

function HorschTigerLT:onAttach(attacherVehicle)
	self.attacherVehicle = attacherVehicle;
	self.Go.HorschTigerLTSupport = true;
	self.Done.HorschTigerLTSupport = true;
	setJointRotationLimit(self.componentJoints[1].jointIndex, 1, true, math.rad(-80), math.rad(80));
	self.doJointOrientation = true;
end;

function HorschTigerLT:onDetach()
	setJointRotationLimit(self.componentJoints[1].jointIndex, 1, true, 0, 0);
	self.Go.HorschTigerLTSupport = false;
	self.Done.HorschTigerLTSupport = true;
	for i=1, table.getn(self.wheels) do
		local wheel = self.wheels[i];
		setWheelShapeProps(wheel.node, wheel.wheelShape, 0, 5, wheel.steeringAngle);
	end;
	if self.attacherJointCopy ~= nil then
		self.attacherJointCopy.minRot = self.rotationCopyMin;
		self.attacherJointCopy.maxRot = self.rotationCopyMax;
		self.attacherJointCopy = nil;
	end;
end;

function HorschTigerLT:getSaveAttributesAndNodes(nodeIdent)
	if self.CheckDone.HorschTigerLTFold then
		trsp = "true";
	else
		trsp = "false";
	end; 	
	local attributes = 'transport="'..trsp..'"';
	return attributes, nil;
end;

function HorschTigerLT:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
    local trsp = getXMLString(xmlFile, key.."#transport");
	if trsp == "true" and not resetVehicles then
		self.moveUp = false;
		self.foldingIn = true;
		self.Go.HorschTigerLTHub = false;
		self.Done.HorschTigerLTHub = true;
		self.Speed.HorschTigerLTFold = 100;
		self.Go.HorschTigerLTFold = true;
		self.Done.HorschTigerLTFold = true;
		self.Go.HorschTigerLTFoldBack = false;
		self.Done.HorschTigerLTFoldBack = true;
		self.Speed.HorschTigerLTFoldBackDrum = 50;
		self.Go.HorschTigerLTFoldBackDrum = true;
		self.Done.HorschTigerLTFoldBackDrum = true;
	end;
    return BaseMission.VEHICLE_LOAD_OK;
end;

function HorschTigerLT:anim(varName, loopCheck)
	local loopCheck = self.loopCheck[varName];
	local speed = Utils.getNoNil(self.Speed[varName],1);
	local offset = 10;  
	local charId = getAnimCharacterSet(self.charId[varName]);
	local clipIndex = getAnimClipIndex(charId, self.clipIndex[varName]);
	if self.Done[varName] ~= false then
		if self.Go[varName] == true then
			assignAnimTrackClip(charId , 0, clipIndex);
			setAnimTrackLoopState(charId, 0, loopCheck);
			setAnimTrackSpeedScale(charId, 0, speed);
			enableAnimTrack(charId, 0);
			if getAnimTrackTime(charId, 0) >= getAnimClipDuration(charId, clipIndex) and loopCheck == false then
				self.Done[varName] = false;	
				self.CheckDone[varName] = self.Go[varName];	
			end;
			if getAnimTrackTime(charId, 0) >= getAnimClipDuration(charId, clipIndex) and loopCheck then
				local setTime = getAnimClipDuration(charId, clipIndex) - getAnimClipDuration(charId, clipIndex);
				setAnimTrackTime(charId, 0, setTime);
			end;
		elseif self.Go[varName] == false then
			if loopCheck == true then
				self.Done[varName] = false;	
			else
				assignAnimTrackClip(charId , 0, clipIndex);
				setAnimTrackLoopState(charId, 0, loopCheck);
				setAnimTrackSpeedScale(charId, 0, -speed);
				enableAnimTrack(charId, 0);
				if getAnimTrackTime(charId, 0) <= 0 then
					self.Done[varName] = false;	
					self.CheckDone[varName] = self.Go[varName];
				end;
			end;
		elseif self.Go[varName] ~= nil then
			assignAnimTrackClip(charId , 0, clipIndex);
			setAnimTrackLoopState(charId, 0, loopCheck);
			if self.Go[varName] < 0.0 then
				self.Go[varName] = 0.0;
			elseif self.Go[varName] > getAnimClipDuration(charId, clipIndex) then
				self.Go[varName] = getAnimClipDuration(charId, clipIndex);
			end;
			if getAnimTrackTime(charId, 0) >= self.Go[varName] then
				setAnimTrackSpeedScale(charId, 0, -speed);
			else
				setAnimTrackSpeedScale(charId, 0, speed);
			end;
			enableAnimTrack(charId, 0);
			if getAnimTrackTime(charId, 0) <= self.Go[varName] + offset and getAnimTrackTime(charId, 0) >= self.Go[varName] - offset then
				self.Done[varName] = false;	
				self.CheckDone[varName] = self.Go[varName];
			end;
		end;
	end;
	if self.Done[varName] == false then
		disableAnimTrack(charId, 0);
	end;
end; 

function HorschTigerLT:aiTurnOn()
	self.moveUp = false;
	self.attacherJointCopy.moveDown = not self.moveUp;
end;

function HorschTigerLT:aiTurnOff()
	self.moveUp = true;
	self.attacherJointCopy.moveDown = not self.moveUp;
end;

function HorschTigerLT:aiLower()
	self.moveUp = false;
end;

function HorschTigerLT:aiRaise()
	self.moveUp = true;
end;